Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/OOO_Engine_Glue/src/OOO_Engine_Glue_genMealy_insert_valack.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/OOO_Engine_Glue/src/OOO_Engine_Glue_genMealy_insert_valack.cpp	(revision 88)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/OOO_Engine_Glue/src/OOO_Engine_Glue_genMealy_insert_valack.cpp	(revision 88)
@@ -0,0 +1,102 @@
+#ifdef SYSTEMC
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/Core/Multi_OOO_Engine/OOO_Engine/OOO_Engine_Glue/include/OOO_Engine_Glue.h"
+
+namespace morpheo                    {
+namespace behavioural {
+namespace core {
+namespace multi_ooo_engine {
+namespace ooo_engine {
+namespace ooo_engine_glue {
+
+
+#undef  FUNCTION
+#define FUNCTION "OOO_Engine_Glue::genMealy_insert_valack"
+  void OOO_Engine_Glue::genMealy_insert_valack (void)
+  {
+    log_begin(OOO_Engine_Glue,FUNCTION);
+    log_function(OOO_Engine_Glue,FUNCTION,_name.c_str());
+
+    uint32_t x=0;
+    for (uint32_t i=0; i<_param->_nb_rename_unit; ++i)
+      {
+        // Transaction must be in-order
+//         Tcontrol_t previous_transaction = true;
+
+        for (uint32_t j=0; j<_param->_nb_inst_insert[i]; ++j)
+          {
+            Tcontrol_t ack                    = PORT_READ(in_INSERT_ACK                    [x]   );
+            Tcontrol_t rename_unit_val        = PORT_READ(in_INSERT_RENAME_UNIT_VAL        [i][j]);
+            Tcontrol_t rename_unit_no_execute = PORT_READ(in_INSERT_RENAME_UNIT_NO_EXECUTE [i][j]);
+            Tcontrol_t commit_unit_ack        = PORT_READ(in_INSERT_COMMIT_UNIT_ACK        [i][j]);
+            Tcontrol_t issue_queue_ack        = PORT_READ(in_INSERT_ISSUE_QUEUE_ACK        [i][j]);
+            
+            
+            
+            // if not execute -> don't route to issue_queue
+            
+            Tcontrol_t val             = (
+//                                           previous_transaction   and
+                                          rename_unit_val        and
+                                          commit_unit_ack        and
+                                          (rename_unit_no_execute or
+                                           issue_queue_ack));
+            Tcontrol_t rename_unit_ack = (
+//                                           previous_transaction   and
+                                          ack                    and
+                                          commit_unit_ack        and
+                                          (rename_unit_no_execute or
+                                           issue_queue_ack));
+            Tcontrol_t commit_unit_val = (
+//                                           previous_transaction   and
+                                          ack                    and
+                                          rename_unit_val        and
+                                          (rename_unit_no_execute or
+                                           issue_queue_ack));
+            Tcontrol_t issue_queue_val = (
+//                                           previous_transaction   and
+                                          ack                    and
+                                          rename_unit_val        and
+                                          commit_unit_ack        and
+                                          not rename_unit_no_execute);
+            
+            PORT_WRITE(out_INSERT_VAL             [x]   ,val            );
+            PORT_WRITE(out_INSERT_RENAME_UNIT_ACK [i][j],rename_unit_ack);
+            PORT_WRITE(out_INSERT_COMMIT_UNIT_VAL [i][j],commit_unit_val);
+            PORT_WRITE(out_INSERT_ISSUE_QUEUE_VAL [i][j],issue_queue_val);
+
+            log_printf(TRACE,OOO_Engine_Glue,FUNCTION,"  * rename_unit [%d].inst_insert[%d] -> %d",i,j,x);
+//          log_printf(TRACE,OOO_Engine_Glue,FUNCTION,"    * previous_transaction              : %d",previous_transaction  );
+            log_printf(TRACE,OOO_Engine_Glue,FUNCTION,"    * insert_val                    (w) : %d",val                   );
+            log_printf(TRACE,OOO_Engine_Glue,FUNCTION,"    * insert_ack                    (r) : %d",ack                   );
+            log_printf(TRACE,OOO_Engine_Glue,FUNCTION,"    * insert_rename_unit_val        (r) : %d",rename_unit_val       );
+            log_printf(TRACE,OOO_Engine_Glue,FUNCTION,"    * insert_rename_unit_ack        (w) : %d",rename_unit_ack       );
+            log_printf(TRACE,OOO_Engine_Glue,FUNCTION,"    * insert_rename_unit_no_execute (r) : %d",rename_unit_no_execute);
+            log_printf(TRACE,OOO_Engine_Glue,FUNCTION,"    * insert_commit_unit_val        (w) : %d",commit_unit_val       );
+            log_printf(TRACE,OOO_Engine_Glue,FUNCTION,"    * insert_commit_unit_ack        (r) : %d",commit_unit_ack       );
+            log_printf(TRACE,OOO_Engine_Glue,FUNCTION,"    * insert_issue_queue_val        (w) : %d",issue_queue_val       );
+            log_printf(TRACE,OOO_Engine_Glue,FUNCTION,"    * insert_issue_queue_ack        (r) : %d",issue_queue_ack       );
+
+            
+//          previous_transaction = VAL and ACK;
+            x ++;
+          }
+      }
+    
+    log_end(OOO_Engine_Glue,FUNCTION);
+  };
+
+}; // end namespace ooo_engine_glue
+}; // end namespace ooo_engine
+}; // end namespace multi_ooo_engine
+}; // end namespace core
+
+}; // end namespace behavioural
+}; // end namespace morpheo              
+#endif
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/OOO_Engine_Glue/src/OOO_Engine_Glue_genMealy_rename.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/OOO_Engine_Glue/src/OOO_Engine_Glue_genMealy_rename.cpp	(revision 88)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/OOO_Engine_Glue/src/OOO_Engine_Glue_genMealy_rename.cpp	(revision 88)
@@ -0,0 +1,41 @@
+#ifdef SYSTEMC
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/Core/Multi_OOO_Engine/OOO_Engine/OOO_Engine_Glue/include/OOO_Engine_Glue.h"
+
+namespace morpheo                    {
+namespace behavioural {
+namespace core {
+namespace multi_ooo_engine {
+namespace ooo_engine {
+namespace ooo_engine_glue {
+
+
+#undef  FUNCTION
+#define FUNCTION "OOO_Engine_Glue::genMealy_rename"
+  void OOO_Engine_Glue::genMealy_rename (void)
+  {
+    log_begin(OOO_Engine_Glue,FUNCTION);
+    log_function(OOO_Engine_Glue,FUNCTION,_name.c_str());
+
+    for (uint32_t i=0; i<_param->_nb_rename_unit; ++i)
+      for (uint32_t j=0; j<_param->_nb_inst_decod[i]; ++j)
+        // if have not front_end_id port, this function is not use
+        PORT_WRITE(out_RENAME_RENAME_UNIT_FRONT_END_ID [i][j],_param->_translate_front_end_id_to_rename_unit [PORT_READ(in_RENAME_FRONT_END_ID [i][j])]);
+    
+    log_end(OOO_Engine_Glue,FUNCTION);
+  };
+
+}; // end namespace ooo_engine_glue
+}; // end namespace ooo_engine
+}; // end namespace multi_ooo_engine
+}; // end namespace core
+
+}; // end namespace behavioural
+}; // end namespace morpheo              
+#endif
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/OOO_Engine_Glue/src/OOO_Engine_Glue_genMealy_retire.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/OOO_Engine_Glue/src/OOO_Engine_Glue_genMealy_retire.cpp	(revision 88)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/OOO_Engine_Glue/src/OOO_Engine_Glue_genMealy_retire.cpp	(revision 88)
@@ -0,0 +1,75 @@
+#ifdef SYSTEMC
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+/*
+#include "Behavioural/Core/Multi_OOO_Engine/OOO_Engine/OOO_Engine_Glue/include/OOO_Engine_Glue.h"
+
+namespace morpheo                    {
+namespace behavioural {
+namespace core {
+namespace multi_ooo_engine {
+namespace ooo_engine {
+namespace ooo_engine_glue {
+
+
+#undef  FUNCTION
+#define FUNCTION "OOO_Engine_Glue::genMealy_retire"
+  void OOO_Engine_Glue::genMealy_retire (void)
+  {
+    log_begin(OOO_Engine_Glue,FUNCTION);
+    log_function(OOO_Engine_Glue,FUNCTION,_name.c_str());
+
+    uint32_t x=0;
+    for (uint32_t i=0; i<_param->_nb_rename_unit; ++i)
+      for (uint32_t j=0; j<_param->_nb_inst_retire[i]; ++j)
+        {
+          Tcontext_t         FRONT_END_ID       = (_param->_have_port_front_end_id)?PORT_READ(in_RETIRE_COMMIT_UNIT_FRONT_END_ID [i][j]):0;
+          Tcontrol_t         WRITE_RD           = PORT_READ(in_RETIRE_COMMIT_UNIT_WRITE_RD           [i][j]);
+          Tgeneral_address_t NUM_REG_RD_PHY_OLD = PORT_READ(in_RETIRE_COMMIT_UNIT_NUM_REG_RD_PHY_OLD [i][j]);
+          Tgeneral_address_t NUM_REG_RD_PHY_NEW = PORT_READ(in_RETIRE_COMMIT_UNIT_NUM_REG_RD_PHY_NEW [i][j]);
+          Tcontrol_t         WRITE_RE           = PORT_READ(in_RETIRE_COMMIT_UNIT_WRITE_RE           [i][j]);
+          Tspecial_address_t NUM_REG_RE_PHY_OLD = PORT_READ(in_RETIRE_COMMIT_UNIT_NUM_REG_RE_PHY_OLD [i][j]);
+          Tspecial_address_t NUM_REG_RE_PHY_NEW = PORT_READ(in_RETIRE_COMMIT_UNIT_NUM_REG_RE_PHY_NEW [i][j]);
+          Tevent_state_t     EVENT_STATE        = PORT_READ(in_RETIRE_COMMIT_UNIT_EVENT_STATE        [i][j]);
+
+          Tgeneral_address_t general_address_msb= FRONT_END_ID << _param->_size_general_register;
+          Tspecial_address_t special_address_msb= FRONT_END_ID << _param->_size_special_register;
+
+          PORT_WRITE(out_RETIRE_RD_OLD_USE     [x],0); 
+          PORT_WRITE(out_RETIRE_RD_OLD_NUM_REG [x],general_address_msb | NUM_REG_RD_PHY_OLD);
+          PORT_WRITE(out_RETIRE_RD_NEW_USE     [x],WRITE_RD);
+          PORT_WRITE(out_RETIRE_RD_NEW_NUM_REG [x],general_address_msb | NUM_REG_RD_PHY_NEW);
+          PORT_WRITE(out_RETIRE_RE_OLD_USE     [x],0); 
+          PORT_WRITE(out_RETIRE_RE_OLD_NUM_REG [x],special_address_msb | NUM_REG_RE_PHY_OLD);
+          PORT_WRITE(out_RETIRE_RE_NEW_USE     [x],WRITE_RE);
+          PORT_WRITE(out_RETIRE_RE_NEW_NUM_REG [x],special_address_msb | NUM_REG_RE_PHY_NEW);
+          
+          if (_param->_have_port_front_end_id)
+          PORT_WRITE(out_RETIRE_RENAME_UNIT_FRONT_END_ID       [i][j],_param->_translate_front_end_id_to_rename_unit [FRONT_END_ID]);
+          PORT_WRITE(out_RETIRE_RENAME_UNIT_WRITE_RD           [i][j],WRITE_RD          );
+          PORT_WRITE(out_RETIRE_RENAME_UNIT_NUM_REG_RD_PHY_OLD [i][j],NUM_REG_RD_PHY_OLD);
+          PORT_WRITE(out_RETIRE_RENAME_UNIT_NUM_REG_RD_PHY_NEW [i][j],NUM_REG_RD_PHY_NEW);
+          PORT_WRITE(out_RETIRE_RENAME_UNIT_WRITE_RE           [i][j],WRITE_RE          );
+          PORT_WRITE(out_RETIRE_RENAME_UNIT_NUM_REG_RE_PHY_OLD [i][j],NUM_REG_RE_PHY_OLD);
+          PORT_WRITE(out_RETIRE_RENAME_UNIT_NUM_REG_RE_PHY_NEW [i][j],NUM_REG_RE_PHY_NEW);
+          PORT_WRITE(out_RETIRE_RENAME_UNIT_EVENT_STATE        [i][j],EVENT_STATE       );
+           
+          x ++;
+        }
+
+    log_end(OOO_Engine_Glue,FUNCTION);
+  };
+
+}; // end namespace ooo_engine_glue
+}; // end namespace ooo_engine
+}; // end namespace multi_ooo_engine
+}; // end namespace core
+
+}; // end namespace behavioural
+}; // end namespace morpheo              
+*/
+#endif
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/OOO_Engine_Glue/src/OOO_Engine_Glue_genMealy_retire_valack.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/OOO_Engine_Glue/src/OOO_Engine_Glue_genMealy_retire_valack.cpp	(revision 88)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/OOO_Engine_Glue/src/OOO_Engine_Glue_genMealy_retire_valack.cpp	(revision 88)
@@ -0,0 +1,61 @@
+#ifdef SYSTEMC
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+/*
+#include "Behavioural/Core/Multi_OOO_Engine/OOO_Engine/OOO_Engine_Glue/include/OOO_Engine_Glue.h"
+
+namespace morpheo                    {
+namespace behavioural {
+namespace core {
+namespace multi_ooo_engine {
+namespace ooo_engine {
+namespace ooo_engine_glue {
+
+
+#undef  FUNCTION
+#define FUNCTION "OOO_Engine_Glue::genMealy_retire_valack"
+  void OOO_Engine_Glue::genMealy_retire_valack (void)
+  {
+    log_begin(OOO_Engine_Glue,FUNCTION);
+    log_function(OOO_Engine_Glue,FUNCTION,_name.c_str());
+
+    uint32_t x=0;
+    for (uint32_t i=0; i<_param->_nb_rename_unit; ++i)
+      for (uint32_t j=0; j<_param->_nb_inst_retire[i]; ++j)
+        {
+          Tcontrol_t ACK             = PORT_READ(in_RETIRE_ACK             [x]   );
+          Tcontrol_t RENAME_UNIT_ACK = PORT_READ(in_RETIRE_RENAME_UNIT_ACK [i][j]);
+          Tcontrol_t COMMIT_UNIT_VAL = PORT_READ(in_RETIRE_COMMIT_UNIT_VAL [i][j]);
+          
+          
+          
+          Tcontrol_t VAL             = (RENAME_UNIT_ACK and
+                                        COMMIT_UNIT_VAL );
+          Tcontrol_t RENAME_UNIT_VAL = (ACK             and
+                                        COMMIT_UNIT_VAL );
+          Tcontrol_t COMMIT_UNIT_ACK = (ACK             and
+                                        RENAME_UNIT_ACK );
+          
+          PORT_WRITE(out_RETIRE_VAL             [x]   , VAL            );
+          PORT_WRITE(out_RETIRE_RENAME_UNIT_VAL [i][j], RENAME_UNIT_VAL);
+          PORT_WRITE(out_RETIRE_COMMIT_UNIT_ACK [i][j], COMMIT_UNIT_ACK);
+           
+          x ++;
+        }
+    
+    log_end(OOO_Engine_Glue,FUNCTION);
+  };
+
+}; // end namespace ooo_engine_glue
+}; // end namespace ooo_engine
+}; // end namespace multi_ooo_engine
+}; // end namespace core
+
+}; // end namespace behavioural
+}; // end namespace morpheo              
+*/
+#endif
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/OOO_Engine_Glue/src/OOO_Engine_Glue_genMealy_spr.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/OOO_Engine_Glue/src/OOO_Engine_Glue_genMealy_spr.cpp	(revision 88)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/OOO_Engine_Glue/src/OOO_Engine_Glue_genMealy_spr.cpp	(revision 88)
@@ -0,0 +1,51 @@
+#ifdef SYSTEMC
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/Core/Multi_OOO_Engine/OOO_Engine/OOO_Engine_Glue/include/OOO_Engine_Glue.h"
+#include "Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Special_Register_unit/include/SPR.h"
+
+namespace morpheo                    {
+namespace behavioural {
+namespace core {
+namespace multi_ooo_engine {
+namespace ooo_engine {
+namespace ooo_engine_glue {
+
+
+#undef  FUNCTION
+#define FUNCTION "OOO_Engine_Glue::genMealy_spr"
+  void OOO_Engine_Glue::genMealy_spr (void)
+  {
+    log_begin(OOO_Engine_Glue,FUNCTION);
+
+    for (uint32_t i=0; i<_param->_nb_front_end; ++i)
+      for (uint32_t j=0; j<_param->_nb_context[i]; ++j)
+        {
+          special_register_unit::SR * sr = new special_register_unit::SR (i,j);
+          
+          sr->write(PORT_READ(in_SPR_SPECIAL_REGISTER_UNIT_SR [i][j]));
+
+          PORT_WRITE(out_SPR_SR_IEE             [i][j],sr->iee);
+          PORT_WRITE(out_SPR_SR_EPH             [i][j],sr->eph);
+          PORT_WRITE(out_SPR_COMMIT_UNIT_SR_OVE [i][j],sr->ove);
+          PORT_WRITE(out_SPR_RENAME_UNIT_SR     [i][j],sr->read());
+
+          delete sr;
+        }
+
+    log_end(OOO_Engine_Glue,FUNCTION);
+  };
+
+}; // end namespace ooo_engine_glue
+}; // end namespace ooo_engine
+}; // end namespace multi_ooo_engine
+}; // end namespace core
+
+}; // end namespace behavioural
+}; // end namespace morpheo              
+#endif
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/OOO_Engine_Glue/src/OOO_Engine_Glue_statistics_allocation.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/OOO_Engine_Glue/src/OOO_Engine_Glue_statistics_allocation.cpp	(revision 88)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/OOO_Engine_Glue/src/OOO_Engine_Glue_statistics_allocation.cpp	(revision 88)
@@ -0,0 +1,39 @@
+#ifdef STATISTICS
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/Core/Multi_OOO_Engine/OOO_Engine/OOO_Engine_Glue/include/OOO_Engine_Glue.h"
+
+namespace morpheo {
+namespace behavioural {
+namespace core {
+namespace multi_ooo_engine {
+namespace ooo_engine {
+namespace ooo_engine_glue {
+
+
+#undef  FUNCTION
+#define FUNCTION "OOO_Engine_Glue::statistics_allocation"
+  void OOO_Engine_Glue::statistics_allocation (morpheo::behavioural::Parameters_Statistics * param_statistics)
+  {
+    log_begin(OOO_Engine_Glue,FUNCTION);
+
+    _stat = new Stat (static_cast<std::string>(_name),
+		      "OOO_Engine_Glue",
+		      param_statistics);
+    
+    log_end(OOO_Engine_Glue,FUNCTION);
+  };
+
+}; // end namespace ooo_engine_glue
+}; // end namespace ooo_engine
+}; // end namespace multi_ooo_engine
+}; // end namespace core
+
+}; // end namespace behavioural
+}; // end namespace morpheo              
+#endif
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/OOO_Engine_Glue/src/OOO_Engine_Glue_statistics_deallocation.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/OOO_Engine_Glue/src/OOO_Engine_Glue_statistics_deallocation.cpp	(revision 88)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/OOO_Engine_Glue/src/OOO_Engine_Glue_statistics_deallocation.cpp	(revision 88)
@@ -0,0 +1,39 @@
+#ifdef STATISTICS
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/Core/Multi_OOO_Engine/OOO_Engine/OOO_Engine_Glue/include/OOO_Engine_Glue.h"
+
+namespace morpheo {
+namespace behavioural {
+namespace core {
+namespace multi_ooo_engine {
+namespace ooo_engine {
+namespace ooo_engine_glue {
+
+
+#undef  FUNCTION
+#define FUNCTION "OOO_Engine_Glue::statistics_deallocation"
+  void OOO_Engine_Glue::statistics_deallocation (void)
+  {
+    log_begin(OOO_Engine_Glue,FUNCTION);
+
+    log_printf(INFO,OOO_Engine_Glue,FUNCTION,_("<%s> : Generate Statistics file"),_name.c_str());
+    
+    delete _stat;
+    
+    log_end(OOO_Engine_Glue,FUNCTION);
+  };
+
+}; // end namespace ooo_engine_glue
+}; // end namespace ooo_engine
+}; // end namespace multi_ooo_engine
+}; // end namespace core
+
+}; // end namespace behavioural
+}; // end namespace morpheo              
+#endif
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/OOO_Engine_Glue/src/OOO_Engine_Glue_transition.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/OOO_Engine_Glue/src/OOO_Engine_Glue_transition.cpp	(revision 88)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/OOO_Engine_Glue/src/OOO_Engine_Glue_transition.cpp	(revision 88)
@@ -0,0 +1,39 @@
+#ifdef SYSTEMC
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/Core/Multi_OOO_Engine/OOO_Engine/OOO_Engine_Glue/include/OOO_Engine_Glue.h"
+
+namespace morpheo                    {
+namespace behavioural {
+namespace core {
+namespace multi_ooo_engine {
+namespace ooo_engine {
+namespace ooo_engine_glue {
+
+
+#undef  FUNCTION
+#define FUNCTION "OOO_Engine_Glue::transition"
+  void OOO_Engine_Glue::transition (void)
+  {
+    log_begin(OOO_Engine_Glue,FUNCTION);
+
+#if defined(STATISTICS) or defined(VHDL_TESTBENCH)
+    end_cycle ();
+#endif
+
+    log_end(OOO_Engine_Glue,FUNCTION);
+  };
+
+}; // end namespace ooo_engine_glue
+}; // end namespace ooo_engine
+}; // end namespace multi_ooo_engine
+}; // end namespace core
+
+}; // end namespace behavioural
+}; // end namespace morpheo              
+#endif
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/OOO_Engine_Glue/src/OOO_Engine_Glue_vhdl.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/OOO_Engine_Glue/src/OOO_Engine_Glue_vhdl.cpp	(revision 88)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/OOO_Engine_Glue/src/OOO_Engine_Glue_vhdl.cpp	(revision 88)
@@ -0,0 +1,48 @@
+#ifdef VHDL
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/Core/Multi_OOO_Engine/OOO_Engine/OOO_Engine_Glue/include/OOO_Engine_Glue.h"
+#include "Behavioural/include/Vhdl.h"
+
+namespace morpheo                    {
+namespace behavioural {
+namespace core {
+namespace multi_ooo_engine {
+namespace ooo_engine {
+namespace ooo_engine_glue {
+
+
+#undef  FUNCTION
+#define FUNCTION "OOO_Engine_Glue::vhdl"
+  void OOO_Engine_Glue::vhdl (void)
+  {
+    log_begin(OOO_Engine_Glue,FUNCTION);
+
+    Vhdl * vhdl = new Vhdl (_name);
+
+    _interfaces->set_port(vhdl);
+    _component->vhdl_instance(vhdl);
+
+    vhdl_declaration (vhdl);
+    vhdl_body        (vhdl);
+
+    vhdl->generate_file();
+
+    delete vhdl;
+
+    log_end(OOO_Engine_Glue,FUNCTION);
+  };
+
+}; // end namespace ooo_engine_glue
+}; // end namespace ooo_engine
+}; // end namespace multi_ooo_engine
+}; // end namespace core
+
+}; // end namespace behavioural
+}; // end namespace morpheo              
+#endif
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/OOO_Engine_Glue/src/OOO_Engine_Glue_vhdl_body.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/OOO_Engine_Glue/src/OOO_Engine_Glue_vhdl_body.cpp	(revision 88)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/OOO_Engine_Glue/src/OOO_Engine_Glue_vhdl_body.cpp	(revision 88)
@@ -0,0 +1,35 @@
+#ifdef VHDL
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/Core/Multi_OOO_Engine/OOO_Engine/OOO_Engine_Glue/include/OOO_Engine_Glue.h"
+
+namespace morpheo                    {
+namespace behavioural {
+namespace core {
+namespace multi_ooo_engine {
+namespace ooo_engine {
+namespace ooo_engine_glue {
+
+
+#undef  FUNCTION
+#define FUNCTION "OOO_Engine_Glue::vhdl_body"
+  void OOO_Engine_Glue::vhdl_body (Vhdl * & vhdl)
+  {
+    log_begin(OOO_Engine_Glue,FUNCTION);
+    vhdl->set_body ("");
+    log_end(OOO_Engine_Glue,FUNCTION);
+  };
+
+}; // end namespace ooo_engine_glue
+}; // end namespace ooo_engine
+}; // end namespace multi_ooo_engine
+}; // end namespace core
+
+}; // end namespace behavioural
+}; // end namespace morpheo              
+#endif
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/OOO_Engine_Glue/src/OOO_Engine_Glue_vhdl_declaration.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/OOO_Engine_Glue/src/OOO_Engine_Glue_vhdl_declaration.cpp	(revision 88)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/OOO_Engine_Glue/src/OOO_Engine_Glue_vhdl_declaration.cpp	(revision 88)
@@ -0,0 +1,34 @@
+#ifdef VHDL
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/Core/Multi_OOO_Engine/OOO_Engine/OOO_Engine_Glue/include/OOO_Engine_Glue.h"
+
+namespace morpheo {
+namespace behavioural {
+namespace core {
+namespace multi_ooo_engine {
+namespace ooo_engine {
+namespace ooo_engine_glue {
+
+
+#undef  FUNCTION
+#define FUNCTION "OOO_Engine_Glue::vhdl_declaration"
+  void OOO_Engine_Glue::vhdl_declaration (Vhdl * & vhdl)
+  {
+    log_begin(OOO_Engine_Glue,FUNCTION);
+    log_end(OOO_Engine_Glue,FUNCTION);
+  };
+
+}; // end namespace ooo_engine_glue
+}; // end namespace ooo_engine
+}; // end namespace multi_ooo_engine
+}; // end namespace core
+
+}; // end namespace behavioural
+}; // end namespace morpheo              
+#endif
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/OOO_Engine_Glue/src/Parameters.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/OOO_Engine_Glue/src/Parameters.cpp	(revision 88)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/OOO_Engine_Glue/src/Parameters.cpp	(revision 88)
@@ -0,0 +1,139 @@
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/Core/Multi_OOO_Engine/OOO_Engine/OOO_Engine_Glue/include/Parameters.h"
+#include "Common/include/Max.h"
+#include "Common/include/BitManipulation.h"
+
+namespace morpheo {
+namespace behavioural {
+namespace core {
+namespace multi_ooo_engine {
+namespace ooo_engine {
+namespace ooo_engine_glue {
+
+#undef  FUNCTION
+#define FUNCTION "OOO_Engine_Glue::Parameters"
+  Parameters::Parameters (uint32_t                nb_front_end                           ,
+                          uint32_t              * nb_context                             ,
+                          uint32_t                nb_rename_unit                         ,
+                          uint32_t              * nb_inst_decod                          ,
+                          uint32_t              * nb_inst_insert                         ,
+                          uint32_t              * nb_inst_retire                         ,
+                          uint32_t                size_general_data                      ,
+                          uint32_t                size_special_data                      ,
+                          uint32_t              * link_rename_unit_with_front_end        ,
+                          std::vector<uint32_t> * translate_front_end_id_from_rename_unit,
+                          uint32_t                size_packet_id                         ,
+                          uint32_t                size_general_register                  ,
+                          uint32_t                size_special_register                  ,
+                          uint32_t                size_store_queue_ptr                   ,
+                          uint32_t                size_load_queue_ptr                    ,
+                          bool                    is_toplevel                            )
+  {
+    log_begin(OOO_Engine_Glue,FUNCTION);
+
+    _nb_front_end                           = nb_front_end                    ;
+    _nb_context                             = nb_context                      ;
+    _nb_rename_unit                         = nb_rename_unit                  ;
+    _nb_inst_decod                          = nb_inst_decod                   ;
+    _nb_inst_insert                         = nb_inst_insert                  ;
+    _nb_inst_retire                         = nb_inst_retire                  ;
+    _link_rename_unit_with_front_end        = link_rename_unit_with_front_end ;
+    _translate_front_end_id_from_rename_unit= translate_front_end_id_from_rename_unit ;
+                                            
+//  _rename_unit_nb_front_end               = rename_unit_nb_front_end        ;
+//  _rename_unit_nb_context                 = rename_unit_nb_context          ;
+//  _rename_unit_size_front_end_id          = rename_unit_size_front_end_id   ;
+//  _rename_unit_size_context_id            = rename_unit_size_context_id     ;
+    _size_rename_id                         = log2(_nb_rename_unit)           ;
+    _sum_inst_insert                        = 0;
+//     _sum_inst_retire                        = 0;
+
+    for (uint32_t i=0; i<_nb_rename_unit; ++i)
+      {
+        _sum_inst_insert += _nb_inst_insert[i];
+//         _sum_inst_retire += _nb_inst_retire[i];
+      }
+
+    _translate_front_end_id_to_rename_unit  = new uint32_t [_nb_front_end];
+    
+    for (uint32_t i=0; i<_nb_front_end; i++)
+      {
+        _translate_front_end_id_to_rename_unit [i]=0;
+        
+        uint32_t x = _link_rename_unit_with_front_end [i];
+
+        for (uint32_t j=0; j<_translate_front_end_id_from_rename_unit [x].size(); ++j)
+          {
+            if (_translate_front_end_id_from_rename_unit [x][j] == i)
+              break;
+            _translate_front_end_id_to_rename_unit [i]++;
+          }
+      }
+    
+    _mask_num_general_register              = gen_mask<Tgeneral_address_t>(size_general_register);
+    _mask_num_special_register              = gen_mask<Tspecial_address_t>(size_special_register);
+
+    test();
+
+    if (is_toplevel)
+      {
+        _size_context_id                        = log2(max<uint32_t>(_nb_context,_nb_front_end));
+        _size_front_end_id                      = log2(_nb_front_end)  ;
+        _size_rob_ptr                           = size_packet_id       ;
+        _size_general_data                      = size_general_data    ;
+        _size_special_data                      = size_special_data    ;
+        _size_general_register                  = size_general_register;
+        _size_special_register                  = size_special_register;
+        _size_store_queue_ptr                   = size_store_queue_ptr ;
+        _size_load_queue_ptr                    = size_load_queue_ptr  ;
+        
+        _have_port_context_id                   = _size_context_id     > 0;
+        _have_port_front_end_id                 = _size_front_end_id   > 0;
+        _have_port_rob_ptr                      = _size_rob_ptr        > 0;
+        _have_port_load_queue_ptr               = _size_load_queue_ptr > 0;
+        
+        copy();
+      }
+
+    log_end(OOO_Engine_Glue,FUNCTION);
+  };
+  
+// #undef  FUNCTION
+// #define FUNCTION "OOO_Engine_Glue::Parameters (copy)"
+//   Parameters::Parameters (Parameters & param)
+//   {
+//     log_begin(OOO_Engine_Glue,FUNCTION);
+//     test();
+//     log_end(OOO_Engine_Glue,FUNCTION);
+//   };
+
+#undef  FUNCTION
+#define FUNCTION "OOO_Engine_Glue::~Parameters"
+  Parameters::~Parameters (void) 
+  {
+    log_begin(OOO_Engine_Glue,FUNCTION);
+    delete _translate_front_end_id_to_rename_unit;
+    log_end(OOO_Engine_Glue,FUNCTION);
+  };
+
+#undef  FUNCTION
+#define FUNCTION "OOO_Engine_Glue::copy"
+  void Parameters::copy (void) 
+  {
+    log_begin(OOO_Engine_Glue,FUNCTION);
+    log_end(OOO_Engine_Glue,FUNCTION);
+  };
+
+}; // end namespace ooo_engine_glue
+}; // end namespace ooo_engine
+}; // end namespace multi_ooo_engine
+}; // end namespace core
+
+}; // end namespace behavioural
+}; // end namespace morpheo              
